from http import HTTPStatus
from typing import Any
from urllib.parse import quote

import httpx

from ... import errors
from ...client import AuthenticatedClient, Client
from ...models.patch_iam_user_filters_filter_body import PatchIamUserFiltersFilterBody
from ...models.patch_iam_user_filters_filter_response_200 import PatchIamUserFiltersFilterResponse200
from ...models.patch_iam_user_filters_filter_response_400 import PatchIamUserFiltersFilterResponse400
from ...models.patch_iam_user_filters_filter_response_401 import PatchIamUserFiltersFilterResponse401
from ...types import Response


def _get_kwargs(
    filter_: str,
    *,
    body: PatchIamUserFiltersFilterBody,
) -> dict[str, Any]:
    headers: dict[str, Any] = {}

    _kwargs: dict[str, Any] = {
        "method": "patch",
        "url": "/iam/user/filters/{filter_}".format(
            filter_=quote(str(filter_), safe=""),
        ),
    }

    _kwargs["json"] = body.to_dict()

    headers["Content-Type"] = "application/json"

    _kwargs["headers"] = headers
    return _kwargs


def _parse_response(
    *, client: AuthenticatedClient | Client, response: httpx.Response
) -> (
    PatchIamUserFiltersFilterResponse200
    | PatchIamUserFiltersFilterResponse400
    | PatchIamUserFiltersFilterResponse401
    | None
):
    if response.status_code == 200:
        response_200 = PatchIamUserFiltersFilterResponse200.from_dict(response.json())

        return response_200

    if response.status_code == 400:
        response_400 = PatchIamUserFiltersFilterResponse400.from_dict(response.json())

        return response_400

    if response.status_code == 401:
        response_401 = PatchIamUserFiltersFilterResponse401.from_dict(response.json())

        return response_401

    if client.raise_on_unexpected_status:
        raise errors.UnexpectedStatus(response.status_code, response.content)
    else:
        return None


def _build_response(
    *, client: AuthenticatedClient | Client, response: httpx.Response
) -> Response[
    PatchIamUserFiltersFilterResponse200 | PatchIamUserFiltersFilterResponse400 | PatchIamUserFiltersFilterResponse401
]:
    return Response(
        status_code=HTTPStatus(response.status_code),
        content=response.content,
        headers=response.headers,
        parsed=_parse_response(client=client, response=response),
    )


def sync_detailed(
    filter_: str,
    *,
    client: AuthenticatedClient,
    body: PatchIamUserFiltersFilterBody,
) -> Response[
    PatchIamUserFiltersFilterResponse200 | PatchIamUserFiltersFilterResponse400 | PatchIamUserFiltersFilterResponse401
]:
    """Update saved filter

     Update a saved filter's name (only name can be updated)

    Args:
        filter_ (str):
        body (PatchIamUserFiltersFilterBody):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[PatchIamUserFiltersFilterResponse200 | PatchIamUserFiltersFilterResponse400 | PatchIamUserFiltersFilterResponse401]
    """

    kwargs = _get_kwargs(
        filter_=filter_,
        body=body,
    )

    response = client.get_httpx_client().request(
        **kwargs,
    )

    return _build_response(client=client, response=response)


def sync(
    filter_: str,
    *,
    client: AuthenticatedClient,
    body: PatchIamUserFiltersFilterBody,
) -> (
    PatchIamUserFiltersFilterResponse200
    | PatchIamUserFiltersFilterResponse400
    | PatchIamUserFiltersFilterResponse401
    | None
):
    """Update saved filter

     Update a saved filter's name (only name can be updated)

    Args:
        filter_ (str):
        body (PatchIamUserFiltersFilterBody):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        PatchIamUserFiltersFilterResponse200 | PatchIamUserFiltersFilterResponse400 | PatchIamUserFiltersFilterResponse401
    """

    return sync_detailed(
        filter_=filter_,
        client=client,
        body=body,
    ).parsed


async def asyncio_detailed(
    filter_: str,
    *,
    client: AuthenticatedClient,
    body: PatchIamUserFiltersFilterBody,
) -> Response[
    PatchIamUserFiltersFilterResponse200 | PatchIamUserFiltersFilterResponse400 | PatchIamUserFiltersFilterResponse401
]:
    """Update saved filter

     Update a saved filter's name (only name can be updated)

    Args:
        filter_ (str):
        body (PatchIamUserFiltersFilterBody):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        Response[PatchIamUserFiltersFilterResponse200 | PatchIamUserFiltersFilterResponse400 | PatchIamUserFiltersFilterResponse401]
    """

    kwargs = _get_kwargs(
        filter_=filter_,
        body=body,
    )

    response = await client.get_async_httpx_client().request(**kwargs)

    return _build_response(client=client, response=response)


async def asyncio(
    filter_: str,
    *,
    client: AuthenticatedClient,
    body: PatchIamUserFiltersFilterBody,
) -> (
    PatchIamUserFiltersFilterResponse200
    | PatchIamUserFiltersFilterResponse400
    | PatchIamUserFiltersFilterResponse401
    | None
):
    """Update saved filter

     Update a saved filter's name (only name can be updated)

    Args:
        filter_ (str):
        body (PatchIamUserFiltersFilterBody):

    Raises:
        errors.UnexpectedStatus: If the server returns an undocumented status code and Client.raise_on_unexpected_status is True.
        httpx.TimeoutException: If the request takes longer than Client.timeout.

    Returns:
        PatchIamUserFiltersFilterResponse200 | PatchIamUserFiltersFilterResponse400 | PatchIamUserFiltersFilterResponse401
    """

    return (
        await asyncio_detailed(
            filter_=filter_,
            client=client,
            body=body,
        )
    ).parsed
